<template>
  <n-modal v-model:show="modalVisible" :mask-closable="false" preset="card" :title="title" class="w-1100px h-500px">
    <n-form ref="formRef" label-placement="left" :label-width="120" :model="formModel" :rules="rules">
      <n-grid :cols="24" :x-gap="20">
        <!-- Col-1 code -->
        <n-form-item-grid-item :span="12" label="Code" path="code">
          <n-input round v-model:value="formModel.code" placeholder="Code"/>
        </n-form-item-grid-item>
        <!-- Col-2 -->
        <n-form-item-grid-item :span="12" label="Gender" path="gender">
          <!-- <n-input round v-model:value="formModel.gender" placeholder="Gender"/> -->
          <n-radio-group v-model:value="formModel.gender" name="radiogroup">
          <n-space>
            <n-radio
              v-for="gender in genders"
              :key="gender.value"
              :value="gender.value"
              :label="gender.label"
            />
          </n-space>
        </n-radio-group>
        </n-form-item-grid-item>
        
         <!-- Col-1 name --> 
         <n-form-item-grid-item :span="12" label="Name" path="name">
          <n-input round v-model:value="formModel.name" placeholder="Name"/>
        </n-form-item-grid-item>
        <!-- Col-2 branchId-->
        <n-form-item-grid-item :span="12" label="Branch" path="branchId">
          <n-select round v-model:value="formModel.branchId" filterable :options="branches" placeholder="Branch"/>
        </n-form-item-grid-item>
        <!-- Col-1 UserName --> 
        <n-form-item-grid-item :span="12" label="User Name" path="userName">
          <n-input round v-model:value="formModel.userName" placeholder="User Name"/>
        </n-form-item-grid-item>
        <!-- Col-2 departmentId-->
        <n-form-item-grid-item :span="12" label="Department" path="departmentId">
          <n-select v-model:value="formModel.departmentId" filterable :options="departments" placeholder="Department"/>
        </n-form-item-grid-item>
        <!-- Col-1 password --> 
        <n-form-item-grid-item :span="12" label="Password" path="password">
          <n-input round v-model:value="formModel.password" placeholder="Password"/>
        </n-form-item-grid-item>
        <!-- Col-2 ruleId --> 
        <n-form-item-grid-item :span="12" label="Rule" path="ruleId">
          <n-select v-model:value="formModel.ruleId" filterable :options="userRules" placeholder="Rule"/>
        </n-form-item-grid-item>
        <!-- Col-1 confirmPassword --> 
        <n-form-item-grid-item :span="12" label="Confirm Password" path="confirmPassword">
          <n-input round v-model:value="formModel.confirmPassword" placeholder="Confirm Password"/>
        </n-form-item-grid-item>
        <!-- Col-2 userStatus --> 
        <n-form-item-grid-item :span="12" label="User Status" path="userStatus">
          <n-select v-model:value="formModel.userStatus" filterable :options="statuses" placeholder="User Status"/>
        </n-form-item-grid-item>
        <!-- ------------------------------------------------------------------------------------ -->
      </n-grid>
      <n-space class="w-full p-5 absolute-bl" :size="24" justify="start"  >
         <n-button secondary size="small" round type="info" @click="handleSubmit">Save</n-button>
        <n-button secondary size="small" round type="info" @click="closeModal">
            Cancel
         </n-button>       
      </n-space>
    </n-form>
  </n-modal>
</template>

<script setup lang="ts">
import { ref, computed, reactive, watch } from 'vue';
import type { FormInst, FormItemRule } from 'naive-ui';
// import { userStatusOptions } from '@/constants';
import { createRequiredFormRule } from '@/utils';
import { useUserAccountStore } from '@/store/index'
const userAccountStore = useUserAccountStore();

// const tableData = ref([]);
export interface Props {
  /** 弹窗可见性 */
  visible: boolean;
  /**
   * 弹窗类型
   * add: 新增
   * edit: 编辑
   */
  type?: 'add' | 'edit';
  /** 编辑的表格行数据 */
  editData?: UserManagement.User | null;
};
var genders: any[];
var userRules: any[];
var branches: any[];
var departments: any[];
var statuses: any[];
export type ModalType = NonNullable<Props['type']>;

defineOptions({ name: 'TableActionModal' });

const props = withDefaults(defineProps<Props>(), {
  type: 'add',
  editData: null
});

interface Emits {
  (e: 'update:visible', visible: boolean): void;
}

const emit = defineEmits<Emits>();

const modalVisible = computed({
  get() {
    return props.visible;
  },
  set(visible) {
    emit('update:visible', visible);
  }
});
const closeModal = () => {
  modalVisible.value = false;
};

const title = computed(() => {
  const titles: Record<ModalType, string> = {
    add: 'UserAccount',
    edit: 'Edit'
  };
  return titles[props.type];
});

const formRef = ref<HTMLElement & FormInst>();

type FormModel = Pick<UserModelObj.User, 'name' | 'code' | 'userName' | 'password' | 'confirmPassword' | 'gender' | 'ruleId' | 'branchId' | 'departmentId' | 'userStatus'>;
// var userModel = [];
const formModel = reactive<FormModel>(createDefaultFormModel());

const rules: Record<keyof FormModel, FormItemRule | FormItemRule[]> = {
  name: createRequiredFormRule('Please enter user Mame'),
  code: createRequiredFormRule('Please enter user code'),
  userName: createRequiredFormRule('Please enter user name'),
  password: createRequiredFormRule('Please enter password'),
  confirmPassword: createRequiredFormRule('Please enter confirm password'),
  gender: createRequiredFormRule('Please select gender'),
  ruleId: createRequiredFormRule('Please select rule'),
  branchId: createRequiredFormRule('Please select branch'),
  departmentId: createRequiredFormRule('Please select department'),
  userStatus: createRequiredFormRule('Please select user status')
};

function createDefaultFormModel(): FormModel {
  return {
    name: '',
    code: '',
    userName: '',
    password: '',
    confirmPassword: '',
    gender: null,
    ruleId: null,
    branchId: null,
    departmentId: null,
    userStatus: null
  };
}

function handleUpdateFormModel(model: Partial<FormModel>) {
  Object.assign(formModel, model);
}

function handleUpdateFormModelByModalType() {
  const handlers: Record<ModalType, () => void> = {
    add: () => {
      const defaultFormModel = createDefaultFormModel();
      handleUpdateFormModel(defaultFormModel);
    },
    edit: () => {
      if (props.editData) {
        handleUpdateFormModel(props.editData);
      }
    }
  };
  handlers[props.type]();
}
async function getUserTemplate() {
    userAccountStore.getUserAccount();
   genders = userAccountStore.genders;
   userRules = userAccountStore.rules;
   statuses = userAccountStore.statuses;
   branches = userAccountStore.branches;
   departments = userAccountStore.departments;
}
async function handleSubmit() {
  // await formRef.value?.validate();
  window.$message?.success('Added successfully!');
  closeModal();
}

watch(
  () => props.visible,
  newValue => {
    if (newValue) {
      getUserTemplate();
      handleUpdateFormModelByModalType();
    }
  }
);
</script>

<style scoped></style>
